#include <stdio.h>
#include <stdlib.h>
#include <string.h>

int main()
{
    char T[200000];
    gets(T);

    int ans = (strlen(T) - 2);
    char *p, *k;
    p = (T + 1);
    k = (T + strlen(T) - 2);

    while(((*p) == (*k)) && (p < k)) {
        p++;
        k--;
        ans -= 2;
    }

    (*(k+1)) = '\0';
    if(ans != 1) {
        while((strchr(p + 1, (*p)) != NULL) && (p <= k)) {
            ans--;
            p++;
        }
    }

    printf("%d", ans);

    return 0;
}